/*
----------------------------------------------
linuxlibrarytest.c

Example using top16linuxlibrary.c, top16linuxlibrary.h

compiled using: gcc -Wall -c linuxlibrarytest.c top16linuxlibrary.c
built using:	gcc -Wall -ldl   linuxlibrarytest.o top16linuxlibrary.o

uses libftd2xx.so  library, (this symbolic link must be installed in you system) 

Modified 15-03-2009



------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <time.h>
#include <dlfcn.h>
#include "top16linuxlibrary.h"

int main(int argc, char** argv) 
{		
	char boardsfound[20][20] ;
	
	char serialNum[255] ="";
	char* serNumEnd ;
	int32_t analogReading ;
	int32_t digitalInputs ;
	uint16_t momentaryPause = 0 ;
	int32_t i = 0 ; 
	int32_t i2 = 0 ;	
	int32_t handle ;
	int inputcount ;
	
	// open the ftdi shared library (libftd2xx.so)
	//
	openLibrary() ;
	
	i = dllversion() ;
	printf("Version %d\n", i) ;
	
	// list all attached top16 boards
	//
	i = ListTop16Boards(boardsfound);		
	printf("Found %d top16 boards.\n", i) ;
	
	// for each board found..
	//
	for(i2 = 0 ; i2 < i; i2++)
	{
		strcpy(serialNum, boardsfound[i2]) ;
		printf("%s\n", serialNum) ;
		
		handle = OpenBoard(serialNum) ;
		if (handle > 0)
		{
			
		  // set half the digital outputs on
		  //
		  SetOutputs(handle, 0xFF, 0) ;    // All off
		  SetOutputs(handle, 0x55, 1) ;    // half on
		  
		  // set output 2 to a half PWM (50:50 duty cycle)
		  //
		  if (SetPWM(handle, 128, 0x2) < 0)   
		  {
		  	  printf("Error setting PWM\n") ;
		  }
		  
		  // read all analog inputs at a gain of 1
		  //
		  for (inputcount = 1 ; inputcount < 9; inputcount++)
		  {
		  	analogReading = readAnalogInput(handle, inputcount, 'Z') ;	
		  	printf("Analog Input %d = %d\n", inputcount, analogReading) ;	  	 
		  	
		  }		  
		  
		  // read all digital inputs
		  //
		  digitalInputs = GetInputs(handle);		  
		  for(inputcount = 1; inputcount < 256; inputcount<<=1)
		  {
		  	if (inputcount & digitalInputs)
		  	{
		  		printf("ON\t") ;
		  	}else
		  	{
		  		printf("off\t") ;
		  	}
		  }
		  printf("\n") ;		  		  
		  
		  CloseBoard(handle) ;
		} 
		
		
		
	}	
	
	// close the ftdi shared library
	//
	closeLibrary() ;		
	
	return(0) ;
}
	
