/*
top16linuxlibrary.h
Functions for top16 io module


20-06-2008			version 1.0  Created  www.tctec.net
15-03-2009			  Version 1.1            Removed util.h
13-09-2010            Version 1.2  Added pulse counting

*/

#ifndef _TOP16AINDLL_H_
#define _TOP16AINDLL_H_



/*
Initialize the FTD2XX library, must be called before any top16 functions below

*/
void openLibrary() ;

/*
Release the FTD2XX library, must be called upon program exit

*/
void closeLibrary() ;


/*
For an explanation of these functions refer to PDF document for top16dll
Or see source file top16linuxlibrary.c

*/

uint32_t OpenBoard(char* board);
int32_t CloseBoard(uint32_t Handle);
int32_t ListTop16Boards(char stringArray[][20]);
int32_t SetOutputs(uint32_t Handle, uint8_t mask, uint8_t set) ;
int32_t GetInputs(uint32_t Handle);
int32_t dllversion() ;
int32_t SetPWM(uint32_t Handle, uint8_t pwm, uint8_t output) ;
uint32_t readAnalogInput(uint32_t Handle, int16_t input, uint8_t gain) ;
uint32_t ReadPulseCount(uint32_t Handle, int16_t input) ;


extern void *FunctionLib;		/* handle to shared lib file */
extern uint32_t (*Function)();		/* Pointer to loaded routine */
extern const char *dlError;	/* Pointer to error string */

#endif /* _TOP16AINDLL_H_ */
